unit RichEditorImpl;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TRichEditor = class(TForm)
    editor: TRichEdit;
    Button1: TButton;
    FontDialog: TFontDialog;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function GetText: string;
    procedure SetText(const Value: string);
  public
    function execute:boolean;
  published
    property Text:string read GetText write SetText;
  end;

var
  RichEditor: TRichEditor;

implementation

{$R *.dfm}

{ TForm1 }

function TRichEditor.execute: boolean;
begin
  result:=showmodal=mrok;
end;

function TRichEditor.GetText: string;
var ss:TStringStream;
begin
  ss:=TStringStream.Create('');
  editor.lines.SaveToStream(ss);
  result:=ss.DataString;
  ss.free;
//  result:=editor.Text;
end;

procedure TRichEditor.SetText(const Value: string);
var ss:TStringStream;
begin
  ss:=TStringStream.Create('');
  ss.WriteString(Value);
  ss.Seek(0, soFromBeginning);
  editor.lines.LoadFromStream(ss);
  ss.free;
//  editor.Text:=Value;
end;

procedure setFont(attr:TTextAttributes; font:TFont);
begin
  with attr do
  begin
    Charset:=Font.Charset;
    Color:=Font.Color;
    Name:=Font.Name;
    Pitch:=Font.Pitch;
    Size:=Font.Size;
    Style:=Font.Style;
    Height:=Font.Height;
  end;
end;

procedure TRichEditor.Button1Click(Sender: TObject);
begin
  if FontDialog.Execute then
  begin
    setFont(editor.SelAttributes, FontDialog.Font);
    setFont(editor.DefAttributes, FontDialog.Font);
  end;
end;

procedure TRichEditor.Button2Click(Sender: TObject);
begin
  if FontDialog.Execute then
    setFont(editor.SelAttributes, FontDialog.Font);
end;

end.
